unit fischu1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ExtCtrls, umFishEx;

const
  cFarbeAus = clBtnFace; cFarbeAusH   = $00E0E0E0;
  cFarbeEin = $0000FF00; cFarbeFehler = $00000FF8;



type                                  
  TFischerMain = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Timer1: TTimer;
    MainMenu1: TMainMenu;
    ComboBox1: TComboBox;
    MemoEingabe: TMemo;
    BInit: TButton;
    MemoFehler: TMemo;
    Programm1: TMenuItem;
    Starten1: TMenuItem;
    N1: TMenuItem;
    Beenden1: TMenuItem;
    BEnde: TButton;
    BStart: TButton;
    ComboBox2: TComboBox;
    BMotorlinks: TButton;
    BMotorrechts: TButton;
    Label1: TLabel;
    BMotorStopp: TButton;
    Timer2: TTimer;
    lblMotor8: TLabel;
    lblMotor7: TLabel;
    lblMotor6: TLabel;
    lblMotor5: TLabel;
    lblMotor4: TLabel;
    lblMotor3: TLabel;
    lblMotor2: TLabel;
    lblMotor1: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    panEingabe: TPanel;
    lblEingabe16: TLabel;
    lblEingabe15: TLabel;
    lblEingabe14: TLabel;
    lblEingabe13: TLabel;
    lblEingabe12: TLabel;
    lblEingabe11: TLabel;
    lblEingabe10: TLabel;
    lblEingabe09: TLabel;
    lblEingabe08: TLabel;
    lblEingabe06: TLabel;
    lblEingabe05: TLabel;
    lblEingabe04: TLabel;
    lblEingabe07: TLabel;
    lblEingabe03: TLabel;
    lblEingabe02: TLabel;
    lblEingabe01: TLabel;
    panAusgabe: TPanel;
    lblDreh16: TLabel;
    lblDreh15: TLabel;
    lblDreh14: TLabel;
    lblDreh13: TLabel;
    lblDreh12: TLabel;
    lblDreh11: TLabel;
    lblDreh10: TLabel;
    lblDreh09: TLabel;
    lblDreh08: TLabel;
    lblDreh07: TLabel;
    lblDreh06: TLabel;
    lblDreh05: TLabel;
    lblDreh04: TLabel;
    lblDreh03: TLabel;
    lblDreh02: TLabel;
    lblDreh01: TLabel;
    LReady: TLabel;
    Hilfe1: TMenuItem;
    Info1: TMenuItem;
    Befehle1: TMenuItem;
    Programm2: TMenuItem;
    Neu1: TMenuItem;
    BNeu: TButton;
    Laden1: TMenuItem;
    Speichern1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    BBreak: TButton;
    Label2: TLabel;
    BLaden: TButton;
    BSpeichern: TButton;
    Label3: TLabel;
    Btest: TButton;
    BTimer2: TButton;
    Label4: TLabel;
    BMotoraus: TButton;
    BalleMaus: TButton;
    Timer3: TTimer;
    LabelX: TLabel;
    LabelY: TLabel;
    procedure BInitClick(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BMotorlinksClick(Sender: TObject);
    procedure BMotorrechtsClick(Sender: TObject);
    procedure BMotorStoppClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure init(PortName : String);
    procedure BStartClick(Sender: TObject);
    procedure interpret;
    procedure Befehle1Click(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Programm2Click(Sender: TObject);
    procedure MemoFehlerChange(Sender: TObject);
    procedure MemoFehlerEnter(Sender: TObject);
    procedure MemoEingabeEnter(Sender: TObject);
    procedure Neu1Click(Sender: TObject);
    procedure Laden1Click(Sender: TObject);
    procedure Speichern1Click(Sender: TObject);
    procedure BBreakClick(Sender: TObject);
    procedure BtestClick(Sender: TObject);
    procedure schleifen_ende;
    procedure BTimer2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BMotorausClick(Sender: TObject);
    procedure BalleMausClick(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);  //wenn die Abbruchbedingung erfllt ist, dann
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  abbruch,test : boolean;
  schleife :array [1..10] of longint;  // enthlt die Sprungmarken
  in_schleife : boolean;     // befindet man sich in einer schleife?
  aufruf :byte;
  FischerMain: TForm;
  motor : array [1..4] of byte;  // welche Aktion sollen die Motoren ausfhren
  EingabeMaske: array[1..16] of LongInt = ($1,    $2,    $4,    $8,
                                           $10,   $20,   $40,   $80,
                                           $100,  $200,  $400,  $800,
                                           $1000, $2000, $4000, $8000);
  EingabeLabel : array [1..16] of TLabel;
  AusgabeLabel : array [1..16] of TLabel;
  Zaehler : array [1..9] of integer;



implementation

uses fischu2;

{$R *.DFM}

function GetInputs(ft: TpftiDCB):LongInt;
       stdcall; external 'umFish.dll';


// Die Procedure Motor_Aktion verndert den Status eines der Motoren
// motor-nr:byte = 1/2/3/4
// status:byte =  0=Motor aus, 1=Motor links und 2=Motor rechts
//               ftiAus=0; ftiEin=1; ftiLinks=1; ftiRechts=2
procedure Motor_Aktion (motor_nr,status:byte);
begin
motor[motor_nr] := status;  //in das Array Motor werden die Motor-Status eingetragen
ftiSetMotor(motor_nr,status);         // Setzen des Motorstatus M[i]
end;


// Die Procedure Init initialisiert das Interface das im Parameter
// PortName bergeben wurde
procedure TFischerMain.init(PortName : String);
begin
if ftiOpenInterface(PortName) = ftiFehler then begin
    MessageDlg('InterfaceProblem : PortName, Strom, Kabel? Oder Interface bereits initialisiert?',
               mtInformation, [mbOK], 0);
    exit;
    end
    else
    begin
    timer1.enabled := true;
    end;
end;


// Beim Tastendruck wird die Procedure Init aufgerufen, welche das Interface einrichten soll
procedure TFischerMain.BInitClick(Sender: TObject); // Init
begin
init(Combobox1.text);  // Com-Port aus Combobox bernehmen
end;


procedure TFischerMain.Beenden1Click(Sender: TObject);  //Programm beenden
begin
close;
end;


// Der Motor Status muss alle 300ms neu ausgegeben werden, damit
// die Motoren sich nicht von alleine ausschalten
procedure TFischerMain.Timer1Timer(Sender: TObject);
var i :byte;
begin
for i := 1 to 4 do
begin
 ftiSetMotor(i,motor[i]);         // Setzen des Motorstatus M[i]
end;
end;


// Zu Begin des Programmes mssen alle Motoren ausgeschatet werde
procedure TFischerMain.FormCreate(Sender: TObject);
var i :byte;
begin
LabelX.caption := 'Analog X =';
LabelY.caption := 'Analog Y =';
for i := 1 to 4 do motor[i] := 0;
end;



procedure TFischerMain.schleifen_ende;  //wenn die Abbruchbedingung erfllt ist, dann
                          // mu die alte Sprungmarke gelscht werden
var zahler:byte;
begin
       zahler := 0;
       repeat
        inc(Zahler,1);
       until (schleife[zahler] = 9999) or (zahler= 10);
       if zahler= 10 then
          begin
          schleife[10] := 9999;
          end
          else
          begin
           if zahler = 2 then
                     begin
                     if test then memofehler.lines.add ('in-schleife = false!');
                     in_schleife := false;
                     end
                     else
                     if test then memofehler.lines.add ('in-schleife = true! Zhler  = '+ inttostr(zahler));

           schleife[zahler-1] := 9999;
          end;
end;



function eingang(welcher:byte):boolean;
var
InputStatus : longint;
begin
InputStatus := ftiGetInputs;
// --- umFish.DLL Patch
    InputStatus := InputStatus and $FF;
//    ftiDCB.MotorStatus := ftiDCB.MotorStatus and $FF;
    if (InputStatus and EingabeMaske[welcher]) <> 0 then
     eingang := true
    else  eingang := false;
end;


//Beim Beenden des Programmes Interfaceverbindung schlieen
procedure TFischerMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
ftiClearMotors;                   // --- Ausschalten aller Ausgnge
ftiCloseInterface;               // --- Interfaceverbindung schlieen
end;





(*
procedure SoundAusgabe (Freq:word);
begin
Windows.Beep (Freq,100);
end;
  *)


// ausgabe von Signaltnen ber den PC-Speaker
//   Funktioniert unter NT leider nicht mehr
procedure SoundAusgabe (Freq:word);
CONST
tonein = $0B6;
ctrlport = $43;
untersetzer = $42;
schalter = $61;
ein_maske = 3;
aus_maske = $0fc;

begin
if Freq <> 0 then
 begin
 asm
 mov al,tonein
 out ctrlport,al
 mov bx,Freq
 mov ax,bx
 out untersetzer,al

 mov al,ah
 out untersetzer,al


 in al,schalter
 and al,aus_maske
 out schalter,al

 in al,schalter
 or al,ein_maske
 out schalter,al
 end;
 end
 else
 begin
 asm
 in al,schalter
 and al,aus_maske
 out schalter,al
 end;
 end;

end;





{***************************************************************************
// Beim Starten des Programmes wird die Memobox "Memoeingabe" Zeilenweise
// verarbeitetund dann die ensprechenden Aktionen ausgefhrt

***************************************************************************}
procedure TFischerMain.interpret;
var
zahler,i,x,x2 :byte;
dummy,dummy2 : string;
teile : array[1..5] of string;
fehler:boolean;
Zzaehler :integer;
Ton:word;
begin


memofehler.text := '';  //Fehler  Memo leeren
memofehler.lines.add('Ablaufprotokoll / Fehlermeldungen:');   //Erste Zeile schreiben

for x := 1 to 10 do schleife[x] := 9999; //keine Schleifen daher alle auf startwert setzen
for x := 1 to 9 do zaehler[x] := 0; //keine Schleifen daher alle auf startwert setzen

in_schleife := false;
test := true;



if memoeingabe.lines.count > 0 then // wenn eine Zeileeingegeben wurde dann starten
begin
memofehler.lines.add('# Interpret Start'); //Interpret Start

i := 0;



repeat  // for i := 0 to (memoeingabe.lines.count-1) do

  //##### Befehlzeile auseinander nehmen max 5 Worte mglich
 dummy := memoeingabe.lines[i];
 for  x := 1 to 5 do teile[x] := ''; //alle Strings aus teile[1..5] lschen

 x := 1;
 repeat
   teile[x] := copy(dummy,0,pos(' ',dummy)-1);
   dummy := copy(dummy,(pos(' ',dummy)+1),length(dummy));
   if (teile[x] = '') and (length(dummy) > 0) then
    begin
    teile[x] := dummy;
    dummy := ''
    end;
   inc(x,1);
 until (x=6) or (dummy='');

  // Nun die Befehle interpretieren und starten.

 fehler := true;


 {-----------------  Interval (in dem alle Motorausgnge noch einmal gesetzt werden) setzten          -------------------------}
  if uppercase (teile[1]) = 'INTERVAL' then
   begin
   timer1.interval := strtoint(teile[2]);
   fehler := false;
   end;



 {-----------------  Mehr Infos ja/nein          -------------------------}
  if uppercase (teile[1]) = 'INFOS' then
   begin
   test := not test;
   fehler := false;
   end;

 {-----------------   Interface schlieen       -------------------------}
  if uppercase (teile[1]) = 'CLOSE' then
   begin
   ftiClearMotors;                   // --- Ausschalten aller Ausgnge
   ftiCloseInterface;               // --- Interfaceverbindung schlieen
   fehler := false;
   end;

 {-----------------   Sound Ausgeben       -------------------------}
  if uppercase (teile[1]) = 'SOUND' then
   begin
   fehler := false;
   Ton := zaehler[strtoint(teile[2][2])];
   soundausgabe(Ton);
   end;

 {-----------------   PC-Speaker abschalten       -------------------------}
  if uppercase (teile[1]) = 'SOUNDAUS' then
   begin
   fehler := false;
   soundausgabe(0);
   end;



 {-----------------   Bedingte Anweisungen             -------------------------}
  if uppercase (teile[1]) = 'WENN' then    // Wenn dann schleife
   begin
   if uppercase (teile[4]) = 'DANN' then
    begin


   if uppercase (teile[2]) = 'E' then   // Eingnge abfragen!!
     begin
     IF ((strtoint(teile[3])) > 0) and (strtoint(teile[3]) < 8) then
     begin     //---
     fehler := false;
     if not (eingang(strtoint(teile[3]))) then
          begin
          x2 := i;
          repeat
          inc(x2,1)
          until (memoeingabe.lines[x2] = ';') or (x2=memoeingabe.lines.count-1) ;
          if memoeingabe.lines[x2] = ';' then i:=x2
                                   else memofehler.lines.add('Ein Bedingung mu mit ";" abgeschlossen werden');
          end;
     end else memofehler.lines.add ('Maximal 8 Eingnge werden abgefragt. Bedingung kann nicht erfllt werden'); //---
     end;

     // Anweisungen berspringen wenn ein Eingang NICHT geschaltet ist!
    if uppercase (teile[2]) = 'NICHT' then
     begin
    if uppercase (teile[3][1]) = 'E' then   // Eingnge abfragen!!
     begin
     IF ((strtoint(teile[3][2])) > 0) and (strtoint(teile[3][2]) < 8) then
     begin     //---
     fehler := false;
     if (eingang(strtoint(teile[3][2]))) then
          begin
          x2 := i;
          repeat
          inc(x2,1)
          until (memoeingabe.lines[x2] = ';') or (x2=memoeingabe.lines.count-1) ;
          if memoeingabe.lines[x2] = ';' then i:=x2
                                   else memofehler.lines.add('Ein Bedingung mu mit ";" abgeschlossen werden');
          end;
     end else memofehler.lines.add ('Maximal 8 Eingnge werden abgefragt. Bedingung kann nicht erfllt werden'); //---
     end;
     end;

     if uppercase ((teile[2][1])) = 'Z' then       // Zhler abfragen
      begin
     IF ((strtoint(teile[3])) >= 0) and (strtoint(teile[3]) <= 10000) then
     begin     //---  berprfen ob Zhler im richtigen bereich
     fehler := false;
     case teile[2][3] of         // -> bug behoben 20.08.01
      '<':
          begin
           if not (Zaehler[strtoint(teile[2][2])] < strtoint(teile[3])) then // -> bug behoben 20.08.01
            begin
               x2 := i;
               repeat
               inc(x2,1)
               until (memoeingabe.lines[x2] = ';') or (x2=memoeingabe.lines.count-1) ;
               if memoeingabe.lines[x2] = ';' then i:=x2
                                    else memofehler.lines.add('Ein Bedingung mu mit ";" abgeschlossen werden');
            end;
          end;
      '=':
          begin
           if not (Zaehler[strtoint(teile[2][2])] = strtoint(teile[3])) then // -> bug behoben 20.08.01
            begin
               x2 := i;
               repeat
               inc(x2,1)
               until (memoeingabe.lines[x2] = ';') or (x2=memoeingabe.lines.count-1) ;
               if memoeingabe.lines[x2] = ';' then i:=x2
                                    else memofehler.lines.add('Ein Bedingung mu mit ";" abgeschlossen werden');
            end;
          end;
      '>':
          begin
           if not (Zaehler[strtoint(teile[2][2])] > strtoint(teile[3])) then // -> bug behoben 20.08.01
            begin
               x2 := i;
               repeat
               inc(x2,1)
               until (memoeingabe.lines[x2] = ';') or (x2=memoeingabe.lines.count-1) ;
               if memoeingabe.lines[x2] = ';' then i:=x2
                                    else memofehler.lines.add('Ein Bedingung mu mit ";" abgeschlossen werden');
            end;
          end;
     end;
     end;
    end;
   end;
  end;


 {-----------------   Zhler setzen        -------------------------}
 if teile[1] <> '' then
 begin
 if uppercase(teile[1]) = 'SETZE' then
    begin
     fehler := false;
     IF ((strtoint(teile[2][2])) > 0) and (strtoint(teile[2][2]) < 10) then
     begin     //---  berprfen ob Zhler im richtigen Bereich
     zaehler[strtoint(teile[2][2])] := strtoint(teile[4]);
     end
     else   memofehler.lines.add ('Nur max. 9 Zhler !! Fehler in Zeile '+inttostr(i));
    end;
 end;

 {-----------------   INC Zhler        -------------------------}
 if uppercase(teile[1]) = 'INC' then
    begin
     fehler := false;
     IF ((strtoint(teile[2][2])) > 0) and (strtoint(teile[2][2]) < 10) then
     begin     //---  berprfen ob Zhler im richtigen Bereich
     zaehler[strtoint(teile[2][2])] := (zaehler[strtoint(teile[2][2])] + strtoint(teile[3]));
     end
     else   memofehler.lines.add ('Nur max. 9 Zhler !! Fehler in Zeile '+inttostr(i));
    end;

 {-----------------   DEC Zhler        -------------------------}
 if uppercase(teile[1]) = 'DEC' then
    begin
     fehler := false;
     IF ((strtoint(teile[2][2])) > 0) and (strtoint(teile[2][2]) < 10) then
     begin     //---  berprfen ob Zhler im richtigen Bereich
     zaehler[strtoint(teile[2][2])] := (zaehler[strtoint(teile[2][2])] - strtoint(teile[3]));
     end
     else   memofehler.lines.add ('Nur max. 9 Zhler !! Fehler in Zeile '+inttostr(i));
    end;


 {-----------------   Leerzeilen als Fehler werten!!!         -------------------------}
  if  teile[1] = '' then
                 begin
                 fehler:= false;  //leerzeilen ignorieren
                 if not in_schleife and test then
                    memofehler.lines.add ('Leerzeile in Zeile '+inttostr(i));
                 end;




 (*  Noch umsetzen!!!
  if (uppercase (teile[1]) = 'ZAEHLE') and (uppercase (teile[3]) = 'IMPULSE') and (uppercase (teile[4]) = 'E') then
    begin
    Zzaehler := 0;
    fehler := false;
   // showmessage('OK');
    repeat

    if eingang (strtoint(teile[5])) then
      begin
      inc (Zzaehler,1);
      showmessage (inttostr(Zzaehler));

      repeat
      until (not eingang (strtoint(teile[5])));
      end;

    until Zzaehler >= strtoint(teile[2]);
    end;
                 *)




 {-----------------   Schleifenabbruch       -------------------------}
  if uppercase (teile[1]) = 'BIS' then
   begin  //1



   if uppercase (teile[2]) = 'E' then   // warten bis Tastendruck
    begin   //1a
    if (strtoint(teile[3]) > 0) and (strtoint(teile[3]) < 9) then
     begin    //1b
     in_schleife := true;
     fehler := false;

     if eingang (strtoint(teile[3])) then
       begin     //
       schleifen_ende;
       if test then memofehler.lines.add('Ende der Schleife. Abbruchbedingung erfllt!');
//       if (test) and (in_schleife=false) then memofehler.lines.add('nicht mehr in Schleife!');
//       if (test) and (in_schleife=true) then memofehler.lines.add('in Schleife!');
       end
       else    //z
       begin
       //Sprung zurck!
       zahler := 0;
       repeat
        inc(Zahler,1);
       until (schleife[zahler] = 9999) or (zahler= 10);
       if zahler= 10 then i := schleife[zahler] else i := schleife[zahler-1];
       // Ende Sprung zurck
       //wenn nicht dann Schleife zurckspringen!:
       if test then
               begin
               memofehler.lines.add('Zurckspringen zu Zeile: '+inttostr(i));
               end;

       end;  //z
    end;   //1b
    end;   //1a


    // warten bis eine Eingang wieder 0 ist!
   if (uppercase(teile[2]) = 'NICHT') and (uppercase(teile[3])='E') then
    begin
    if (strtoint(teile[4]) > 0) and (strtoint(teile[4]) < 9) then
     begin
     in_schleife := true;
     fehler := false;

     if not (eingang(strtoint(teile[4]))) then
       begin
       schleifen_ende;
       if test then memofehler.lines.add('Ende der Schleife. Abbruchbedingung erfllt!');
       end
       else
       begin
       //Sprung zurck!
       zahler := 0;
       repeat
        inc(Zahler,1);
       until (schleife[zahler] = 9999) or (zahler= 10);
       if zahler= 10 then i := schleife[zahler] else i := schleife[zahler-1];
       // Ende Sprung zurck
       //wenn nicht dann Schleife zurckspringen!:
       if test then
               begin
               memofehler.lines.add('Zurckspringen zu Zeile: '+inttostr(i));
               end;

       end;
    end;
    end;


  if uppercase (teile[2]) = 'ABBRUCH' then
    begin   //2a
    in_schleife := true;
    fehler := false;
    if abbruch then
       begin   //2b
       schleifen_ende;
      if test then memofehler.lines.add('Ende der Schleife. Abbruchbedingung erfllt!');
//       if (test) and (in_schleife=false) then memofehler.lines.add('nicht mehr in Schleife!');
//       if (test) and (in_schleife=true) then memofehler.lines.add('in Schleife!');
       end
       else      //2b
       begin
       //Sprung zurck!
       zahler := 0;
       repeat
        inc(Zahler,1);
       until (schleife[zahler] = 9999) or (zahler= 10);
       if zahler= 10 then i := schleife[zahler] else i := schleife[zahler-1];
       // Ende Sprung zurck
       //wenn nicht dann Schleife zurckspringen!:
       if test then
               begin
               memofehler.lines.add('Zurckspringen zu Zeile: '+inttostr(i));
               end;

       end;      //2b
    end;     //2a

   if uppercase (teile[2]) = 'ESC' then
    begin    //3a
    in_schleife := true;
    fehler := false;
    //Abbruch???
    if ftiFinish(1) then
       begin     //3b
       schleifen_ende;
       if test then memofehler.lines.add('Ende der Schleife. Abbruchbedingung erfllt!');
       if (test) and (in_schleife=false) then memofehler.lines.add('nicht mehr in Schleife!');
       end
       else    //3b
       begin
       //wenn nicht dann Schleife zurckspringen!:
       if test then
               begin
               memofehler.lines.add('Zurckspringen!');
               memofehler.lines.add('Zurckspringen zu Zeile: '+inttostr(i));
               end;
       //Sprung zurck!
       zahler := 0;
       repeat
        inc(Zahler,1);
       until (schleife[zahler] = 9999) or (zahler= 10);
       if zahler= 10 then i := schleife[zahler] else i := schleife[zahler-1];
       // Ende Sprung zurck
       end;      //3b
    end;       //3a


    if uppercase (teile[2][1]) = 'Z' then
    begin    //4a
    in_schleife := true;
    fehler := false;
    //Abbruch???

    case teile[2][3] of
     '>':
          begin
           if zaehler[strtoint(teile[2][2])] > strtoint(teile[3]) then
           begin     //4b
           schleifen_ende;
           if test then memofehler.lines.add('Ende der Schleife. Abbruchbedingung erfllt!');
           if (test) and (in_schleife=false) then memofehler.lines.add('nicht mehr in Schleife!');
           end
           else    //4b
           begin
           //wenn nicht dann Schleife zurckspringen!:
           if test then
               begin
               memofehler.lines.add('Zurckspringen!');
               memofehler.lines.add('Zurckspringen zu Zeile: '+inttostr(i));
               end;
                //Sprung zurck!
                zahler := 0;
                repeat
                inc(Zahler,1);
                until (schleife[zahler] = 9999) or (zahler= 10);
                if zahler= 10 then i := schleife[zahler] else i := schleife[zahler-1];
                // Ende Sprung zurck
            end;      //4b
          end;
     '=':
          begin
           if zaehler[strtoint(teile[2][2])] = strtoint(teile[3]) then
           begin     //4b
           schleifen_ende;
           if test then memofehler.lines.add('Ende der Schleife. Abbruchbedingung erfllt!');
           if (test) and (in_schleife=false) then memofehler.lines.add('nicht mehr in Schleife!');
           end
           else    //4b
           begin
           //wenn nicht dann Schleife zurckspringen!:
           if test then
               begin
               memofehler.lines.add('Zurckspringen!');
               memofehler.lines.add('Zurckspringen zu Zeile: '+inttostr(i));
               end;
                //Sprung zurck!
                zahler := 0;
                repeat
                inc(Zahler,1);
                until (schleife[zahler] = 9999) or (zahler= 10);
                if zahler= 10 then i := schleife[zahler] else i := schleife[zahler-1];
                // Ende Sprung zurck
            end;      //4b
          end;
     '<':
          begin
           if zaehler[strtoint(teile[2][2])] < strtoint(teile[3]) then
           begin     //4b
           schleifen_ende;
           if test then memofehler.lines.add('Ende der Schleife. Abbruchbedingung erfllt!');
           if (test) and (in_schleife=false) then memofehler.lines.add('nicht mehr in Schleife!');
           end
           else    //4b
           begin
           //wenn nicht dann Schleife zurckspringen!:
           if test then
               begin
               memofehler.lines.add('Zurckspringen!');
               memofehler.lines.add('Zurckspringen zu Zeile: '+inttostr(i));
               end;
                //Sprung zurck!
                zahler := 0;
                repeat
                inc(Zahler,1);
                until (schleife[zahler] = 9999) or (zahler= 10);
                if zahler= 10 then i := schleife[zahler] else i := schleife[zahler-1];
                // Ende Sprung zurck
            end;      //4b
          end;
    end;



    end;       //4a







   end; //1!!!



 {-----------------   Signalton ausgeben             -------------------------}

 if uppercase (teile[1]) = 'BEEP' then beep;  // Signalton ausgeben


 {-----------------   Schleife REPEAT UNTIL          -------------------------}

 if uppercase (teile[1]) = 'WIEDERHOLE' then
   begin
    if uppercase (teile[2]) = 'SOLANGE' then
    begin
    if test then memofehler.lines.add ('Beginne Schleife');
    zahler := 1;
    repeat
        if schleife[zahler] = 9999 then
          begin
          schleife[zahler] := i; //startpunkt der schleife speichern!
          if test then memofehler.lines.add ('Schleife['+inttostr(zahler)+']='+inttostr(i+1));
          zahler := zahler + 10;
          end;
    inc(Zahler,1);
    until zahler >= 10;
    if (zahler > 20) or (zahler=10) then memofehler.Lines.add ('Zuviele geschachtelte Schleifen! Maximal 9 geschachtelte Schleifen mglich!');
    fehler := false;
    end;
   end;



 {-----------------   Kommentar auswerten             -------------------------}
  if teile[1] = '#' then
    begin
    if not in_schleife then memofehler.lines.add(memoeingabe.lines[i]);
    fehler:= false;
    end;

 {-----------------   Variablen Wert in Pop-Up Fenster ausgeben             -------------------------}
  if (uppercase(teile[1]) = 'ZEIGE') and (uppercase(teile[2]) ='WERT') then
    begin
    showmessage ('Variable '+teile[3][2]+' hat den Wert '+inttostr(Zaehler[strtoint(teile[3][2])]) );
    fehler:= false;
    end;

 {-----------------   Ausgabedevice sperren fr neue Befehle-----------------------}
  if uppercase(teile[1]) = 'DELAY' then
    begin
      if (uppercase(teile[2][1])='Z') then
      begin
      ftiWaitForTime(Zaehler[strtoint(teile[2][2])]);            // --- Warten Wert Variable mSek
      fehler := false;
      end
      else
      begin
       if (strtoint(teile[2])>0) and (strtoint(teile[2])<100000)
       then
       begin
       ftiWaitForTime(strtoint(teile[2]));            // --- Warten teile[2] mSek
       fehler := false;
       end;
      end;

     end;


 {-----------------   Motoren aus/einschalten  -------------------------}
  if uppercase(teile[1]) = 'MOTOR' then
      begin
       if uppercase(teile[3]) = 'AUS' then
        begin

        motor_Aktion(strtoint(teile[2]),0);
        fehler := false;
        end;
       if uppercase(teile[3]) = 'LINKS' then
        begin
        motor_Aktion(strtoint(teile[2]),1);
        fehler := false;
        end;
       if uppercase(teile[3]) = 'RECHTS' then
        begin
        if (strtoint(teile[2])<5) and (strtoint(teile[2])>0) then
        begin motor_Aktion(strtoint(teile[2]),2); fehler := false; end;
        end;
      end;

 {-----------------   Interface initalisieren  -------------------------}
    if uppercase(teile[1]) = 'INIT' then
      begin
      if (uppercase(teile[2]) = 'COM1')
       or (uppercase(teile[2]) = 'COM2')
       or (uppercase(teile[2]) = 'COM3')
       or (uppercase(teile[2]) = 'COM4')
         then
         begin
          init(Teile[2]);
          fehler:= false;
         end;

      end;


     if fehler = true then
     begin
      //messagebeep(MB_ICONQUESTION);
      //if not in_schleife then
           memofehler.lines.add('Fehler in Zeile '+inttostr(i)+' -> '+memoeingabe.lines[i]);
      end;
inc (i,1);

                   //OK

until i = (memoeingabe.lines.count) ; //werst aufhren wenn alle schritte abgearbeitet wurden

memofehler.lines.add('# Interpret Stopp'); //Interpret Stopp
end  //abfrage ob berhaupt eingaben im Memo
else
 begin
  memofehler.lines.add('# kein Programm geladen'); //Interpret Stopp
 end;



end;


// Steuern der Motoren durch Tastendruck
procedure TFischerMain.BMotorlinksClick(Sender: TObject);
begin
Motor_Aktion(strtoint(combobox2.text),1);
end;

// Steuern der Motoren durch Tastendruck
procedure TFischerMain.BMotorrechtsClick(Sender: TObject);
begin
Motor_Aktion(strtoint(combobox2.text),2);
end;

// Steuern der Motoren durch Tastendruck
procedure TFischerMain.BMotorStoppClick(Sender: TObject);
begin
Motor_Aktion(strtoint(combobox2.text),0);
end;

// Informationen ber Interface bei jedem Intervall neu abfragen
procedure TFischerMain.Timer2Timer(Sender: TObject);
var i :byte;
InputStatus : longint;
begin
InputStatus := ftiGetInputs;

  if InputStatus = ftiFehler then
    begin                                   // --- Status-Indikator
    LReady.color := cFarbeFehler;
    exit
    end
  else LReady.color := cFarbeEin;

// --- umFish.DLL Patch
    InputStatus := InputStatus and $FF;
//    ftiDCB.MotorStatus := ftiDCB.MotorStatus and $FF;


  for i := 1 to 16 do                      // --- Ein- und Ausgabezeile
    begin
    if (InputStatus and EingabeMaske[i])<>0 then
     EingabeLabel[i].Color := cFarbeEin
    else EingabeLabel[i].Color := cFarbeAus;

{
  if (ftiDCB.MotorStatus and EingabeMaske[i])<>0 then
     AusgabeLabel[i].Color := cFarbeEin
    else AusgabeLabel[i].Color := cFarbeAus;}
    end;
end;



// -----
// Starten des Interprets
// -----
procedure TFischerMain.BStartClick(Sender: TObject);
begin
interpret;
end;

// -----
// Anzeigen der Informationen 1
// -----
procedure TFischerMain.Befehle1Click(Sender: TObject);
begin
aufruf := 1;
info.showmodal;
end;

// -----
// Anzeigen der Informationen 3
// -----
procedure TFischerMain.Info1Click(Sender: TObject);
begin
aufruf := 3;
info.showmodal;
end;

// -----
// Anzeigen der Informationen 2
// -----
procedure TFischerMain.Programm2Click(Sender: TObject);
begin
aufruf := 2;
info.showmodal;
end;

// -----
// auf den Anfang zurckspringen
// -----
procedure TFischerMain.MemoFehlerChange(Sender: TObject);
begin
memofehler.selstart := 0;
end;

// -----
// auf den Anfang zurckspringen
// -----
procedure TFischerMain.MemoFehlerEnter(Sender: TObject);
begin
memofehler.selstart := 0;
end;


// -----
// auf den Anfang zurckspringen
// -----
procedure TFischerMain.MemoEingabeEnter(Sender: TObject);
begin
memoeingabe.selstart := 0;
end;


// -----
// Memofeld lschen
// -----
procedure TFischerMain.Neu1Click(Sender: TObject);
begin
memoeingabe.text := '';
memofehler.text := '';
memofehler.lines.add('Fehlermeldungen:');
end;


// -----
// Altes Programm laden
// -----
procedure TFischerMain.Laden1Click(Sender: TObject);
var
dummy,woher : string;
Filename: TextFile;
x : byte;
begin
if opendialog1.Execute then          { Dateidialog ffnen }
  begin
  memoeingabe.Text := '';
  woher := opendialog1.filename;
  if (woher[length(woher)-3]) <> '.' then woher := woher + '.ffl';
    AssignFile(Filename,woher);  { im Dialogfeld ausgewhlte Datei }
    Reset (Filename);
    repeat
    readln(Filename,dummy);
    memoeingabe.lines.add (dummy);
    until eof(filename);

    CloseFile(Filename);
  end;
end;

// -----
// Neues Programm speichern
// -----
procedure TFischerMain.Speichern1Click(Sender: TObject);
var
wohin : string;
Filename: TextFile;
x : byte;
begin
if savedialog1.Execute then          { Dateidialog ffnen }
  begin
  wohin := savedialog1.filename;
  if (wohin[length(wohin)-3]) <> '.' then wohin := wohin + '.ffl';
    AssignFile(Filename,wohin);  { im Dialogfeld ausgewhlte Datei }
    Rewrite (Filename);

    for x := 0 to memoeingabe.lines.count do
      begin
      writeln (Filename,memoeingabe.lines[x]);
      end;

    CloseFile(Filename);
  end;
end;

// -----
// Abbruchschalter setzen
// -----
procedure TFischerMain.BBreakClick(Sender: TObject);
begin
if abbruch then abbruch := false else abbruch := true;
if abbruch then label2.color := clRED else label2.Color := clGreen;
end;

// Im Moment Ohne Funktion
procedure TFischerMain.BtestClick(Sender: TObject);
begin
if test then test := false else test := true;
if test then label3.color := clRED else label3.Color := clGreen;
end;

// Anzeigen von Interface Informationen ein/aus
procedure TFischerMain.BTimer2Click(Sender: TObject);
begin
timer2.Enabled := not timer2.enabled;
timer3.Enabled := not timer3.enabled;
if timer2.enabled then label4.color := clgreen else label4.color := clred;
end;

procedure TFischerMain.FormShow(Sender: TObject);
begin
  EingabeLabel[01] := lblEingabe01;
  EingabeLabel[02] := lblEingabe02;
  EingabeLabel[03] := lblEingabe03;
  EingabeLabel[04] := lblEingabe04;
  EingabeLabel[05] := lblEingabe05;
  EingabeLabel[06] := lblEingabe06;
  EingabeLabel[07] := lblEingabe07;
  EingabeLabel[08] := lblEingabe08;
  EingabeLabel[09] := lblEingabe09;
  EingabeLabel[10] := lblEingabe10;
  EingabeLabel[11] := lblEingabe11;
  EingabeLabel[12] := lblEingabe12;
  EingabeLabel[13] := lblEingabe13;
  EingabeLabel[14] := lblEingabe14;
  EingabeLabel[15] := lblEingabe15;
  EingabeLabel[16] := lblEingabe16;
end;

procedure TFischerMain.BMotorausClick(Sender: TObject);
begin
beep;
ftiClearMotors;                   // --- Ausschalten aller Ausgnge
ftiCloseInterface;               // --- Interfaceverbindung schlieen
end;


// Alle Motoren ausschalten
procedure TFischerMain.BalleMausClick(Sender: TObject);
var i : byte;
begin
for i := 1 to 4 do
    motor[i]:=0;
end;

// Analogeingnge fters abragen als die anderen Eingnge
procedure TFischerMain.Timer3Timer(Sender: TObject);
begin
labelX.caption := '                           ';
labelY.caption := '                           ';
labelX.caption := 'AnalogX = '+inttostr(ftigetAnalog(0));
labelY.caption := 'AnalogY = '+inttostr(ftigetAnalog(1));
end;


end.
